<meta charset="UTF-8"/>
<!--
///////////////////////////////////////////////////////////////////////////////////
//                     Copyright (C) 2021 Dr Robert P. Wolf                      //
//                                                                               //
// Permission is hereby granted, free of charge, to any person obtaining a copy  //
// of this software and associated documentation files (the "Software"), to deal //
// in the Software without restriction, including without limitation the rights  //
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell     //
// copies of the Software, and to permit persons to whom the Software is         //
// furnished to do so, subject to the following conditions:                      //
//                                                                               //
// The above copyright notice and this permission notice shall be included in    //
// all copies or substantial portions of the Software.                           //
//                                                                               //
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR    //
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,      //
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE   //
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER        //
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, //
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN     //
// THE SOFTWARE.                                                                 //
///////////////////////////////////////////////////////////////////////////////////

-->
<html>
	<head>
		<title>Graphoplex Koh-I-Noor 10010</title>
		<link rel="shortcut icon" type="image/x-icon" href="../h.ico"/>
	</head>

<body background="Koh-i-noor_1.1.jpg" style="background-size: cover;">
	<div style="font-family: arial; color: gold; text-shadow: 2px 2px blue;">
		<input type = checkbox id = on_side onchange = "javascript: changeMarkings ('stator', this . checked);" />Markings on side.
		<input type = checkbox id = on_hairline onchange = "javascript: changeMarkings ('hairline', this . checked);" />Markings on centre hairline.
		<input type = radio name = other_side id=visible_front onclick="javascript: changeSide ('front');" checked=true/>Front
	    <input type = radio name = other_side id=visible_back onclick="javascript: changeSide ('back');"/>Back
	    <input type = radio name = other_side id=visible_both onclick="javascript: changeSide ('both');"/>Both sides
	</div>
<div id="root"/>

<script src="sliderule_construction_kit.js"></script>
<script src="scales.js"></script>

<script>

var brace = function (left, shift, rounding, braceRadius, angle, tensor, colour) {
	this . draw = function (ctx, s) {
		ctx . save ();
		var height = s . height ();
		var half = height * 0.5;
		ctx . beginPath ();
		ctx . moveTo (shift, 0);
		ctx . bezierCurveTo (shift - tensor . x, tensor . y, shift - tensor . x, height - tensor . y, shift, height);
		ctx . lineTo (left + rounding, height);
		ctx . arc (left + rounding, height - rounding, rounding, Math . PI * 0.5, Math . PI);
		ctx . lineTo (left, half + Math . sin (angle) * braceRadius);
		ctx . arc (left - Math . cos (angle) * braceRadius, half, braceRadius, angle, - angle, true);
		ctx . lineTo (left, rounding);
		ctx . arc (left + rounding, rounding, rounding, Math . PI, Math . PI * 1.5);
		ctx . closePath ();
		ctx . fillStyle = colour;
		ctx . fill ();
		var right = (1 + s . left_margin + s . right_margin) * s . length;
		var sh = right - shift;
		right -= left;
		ctx . beginPath ();
		ctx . moveTo (sh, height);
		ctx . bezierCurveTo (sh + tensor . x, height - tensor . y, sh + tensor . x, tensor . y, sh, 0);
		ctx . lineTo (right - rounding, 0);
		ctx . arc (right - rounding, rounding, rounding, Math . PI * -0.5, 0);
		ctx . lineTo (right, half - Math . sin (angle) * braceRadius);
		ctx . arc (right + Math . cos (angle) * braceRadius, half, braceRadius, Math . PI + angle, Math . PI - angle, true);
		ctx . lineTo (right, height - rounding);
		ctx . arc (right - rounding, height - rounding, rounding, 0, Math . PI * 0.5);
		ctx . closePath ();
		ctx . fill ();
		ctx . restore ();
	};
};

var supports = function (left, top, width, height, radius, colour) {
	this . draw = function (ctx, s) {
		var h = s . height () - top;
		ctx . save ();
		ctx . beginPath ();
		ctx . moveTo (left + width - radius, top);
		ctx . arc (left + width - radius, top + radius, radius, Math . PI * -0.5, 0);
		ctx . lineTo (left + width, top + height - radius);
		ctx . arc (left + width - radius, top + height - radius, radius, 0, Math . PI * 0.5);
		ctx . lineTo (left + radius, top + height);
		ctx . arc (left + radius, top + height - radius, radius, Math . PI * 0.5, Math . PI);
		ctx . lineTo (left, top + radius);
		ctx . arc (left + radius, top + radius, radius, Math . PI, Math . PI * 1.5);
		ctx . closePath ();
		ctx . fillStyle = colour;
		ctx . fill ();
		ctx . beginPath ();
		ctx . moveTo (left + width - radius, h - height);
		ctx . arc (left + width - radius, h - height + radius, radius, Math . PI * -0.5, 0);
		ctx . lineTo (left + width, h);
		ctx . arc (left + width - radius, h - radius, radius, 0, Math . PI * 0.5);
		ctx . lineTo (left + radius, h);
		ctx . arc (left + radius, h - radius, radius, Math . PI * 0.5, Math . PI);
		ctx . lineTo (left, h - height + radius);
		ctx . arc (left + radius, h - height + radius, radius, Math . PI, Math . PI * 1.5);
		ctx . closePath ();
		ctx . fill ();
		var right = (1 + s . left_margin + s . right_margin) * s . length - left;
		ctx . beginPath ();
		ctx . moveTo (right - radius, top);
		ctx . arc (right  - radius, top + radius, radius, Math . PI * -0.5, 0);
		ctx . lineTo (right, top + height - radius);
		ctx . arc (right - radius, top + height - radius, radius, 0, Math . PI * 0.5);
		ctx . lineTo (right - width + radius, top + height);
		ctx . arc (right - width + radius, top + height - radius, radius, Math . PI * 0.5, Math . PI);
		ctx . lineTo (right - width, top + radius);
		ctx . arc (right - width + radius, top + radius, radius, Math . PI, Math . PI * 1.5);
		ctx . closePath ();
		ctx . fill ();
		ctx . beginPath ();
		ctx . moveTo (right - radius, h - height);
		ctx . arc (right - radius, h - height + radius, radius, Math . PI * -0.5, 0);
		ctx . lineTo (right, h - radius);
		ctx . arc (right - radius, h - radius, radius, 0, Math . PI * 0.5);
		ctx . lineTo (right - width + radius, h);
		ctx . arc (right - width + radius, h - radius, radius, Math . PI * 0.5, Math . PI); 
		ctx . lineTo (right - width, h - height + radius);
		ctx . arc (right - width + radius, h - height + radius, radius, Math . PI, Math . PI * 1.5);
		ctx . closePath ();
		ctx . fill ();
		ctx . restore ();
	};
};

var logo = new Image (); logo . src = 'Kohinoor_logo.png';
var graphoplex = new Image (); graphoplex . src = 'Graphoplex_Logo_Red.png';
var sliderules = new Sliderules ();

var s = new Sliderule (1200, {left_margin: 0.16, right_margin: 0.16, cursor_left_extension: 0.07, cursor_right_extension: 0.07}); sliderules . sliderules . push (s);
s . braces . push (new brace (0, 70, 12, 80, 0.6, {x: 20, y: 50}, 'gray'));
s . braces . push (new brace (5, 65, 12, 80, 0.6, {x: 20, y: 50}, 'blue'));
s . braces . push (new supports (20, 10, 20, 32, 4, 'gray'));
s . braces . push (new supports (22, 12, 14, 28, 4, 'blue'));

var r = new Rule ({left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . scales . push (new spacer (4));
r . scales . push (new scale_LL02 (18, {left: 'LL02', ls: 0.06, right: '1/e\u2070\u22c5\u00b9\u02e3', rs: 0.06, left_extension: 0.027, right_extension: 0.022, marking_colour: 'red'}));
r . scales . push (new scale_LL03 (18, {left: 'LL03', ls: 0.06, right: '1/e\u02e3', rs: 0.06, left_extension: 0.027, right_extension: 0.036, marking_colour: 'red'}));
r . scales . push (new scale_CF (18, {left: 'DF', ls: 0.06, right: '\u03c0X', rs: 0.06, left_extension: 0.021, right_extension: 0.022}));

r = new Rule ({stator: 1, left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . markings . push (new Logo (logo, 1.072, 45, 0.11));
r . markings . push (new Engraving ('10010', '9px arial', 'center', 'black', 1.072, 70));
r . markings . push (new Logo (graphoplex, -0.1, 45, 0.125, Math . PI * 1.5));
r . markings . push (new Engraving ('FRANCE', '8px times', 'center', 'red', -0.085, 45, Math . PI * 1.5));
r . scales . push (new scale_DF (18, {left: 'CF', ls: 0.06, left_extension: 0.021, right_extension: 0.022}));
r . scales . push (new scale_CIF (18, {left: 'CIF', ls: 0.06, colour: 'red', left_extension: 0.018, right_extension: 0.028}));
r . scales . push (new scale_K (18, {left: 'K', ls: 0.06, lines: [{left: 0, right: 1, height: 1}]}));
r . scales . push (new scale_CI (18, {left: 'CI', ls: 0.06, colour: 'red'}));
r . scales . push (new scale_C (18, {left: 'C', ls: 0.06, left_extension: 0.048, right_extension: 0.044}));

r = new Rule ({left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . scales . push (new scale_D (18, {left: 'D', ls: 0.06, right: 'X', rs: 0.07, left_extension: 0.048, right_extension: 0.044}));
r . scales . push (new scale_LL3_down (18, {left: 'LL3', ls: 0.065, right: 'e\u02e3', rs: 0.07, left_extension: 0.04, right_extension: 0.064}));
r . scales . push (new scale_LL2_down (18, {left: 'LL2', ls: 0.065, right: 'e\u2070\u22c5\u00b9\u02e3', rs: 0.07, left_extension: 0.021, right_extension: 0.042}));
r . scales . push (new spacer (4));

var s = new Sliderule (1200, {left_margin: 0.16, right_margin: 0.16, cursor_left_extension: 0.07, cursor_right_extension: 0.07}); sliderules . sliderules . push (s);
s . braces . push (new brace (0, 70, 12, 80, 0.6, {x: 20, y: 50}, 'gray'));
s . braces . push (new brace (5, 65, 12, 80, 0.6, {x: 20, y: 50}, 'blue'));
s . braces . push (new supports (20, 10, 20, 32, 4, 'gray'));
s . braces . push (new supports (22, 12, 14, 28, 4, 'blue'));

var r = new Rule ({left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . scales . push (new spacer (4));
r . scales . push (new scale_LL01 (18, {left: 'LL01', ls: 0.064, right: '1/e\u2070\u22c5\u2070\u00b9\u02e3', rs: 0.052, left_extension: 0.022, right_extension: 0.024, marking_colour: 'red'}));
r . scales . push (new scale_L (18, {left: 'L', ls: 0.064, right: 'Log X', rs: 0.052}));
r . scales . push (new scale_A (18, {left: 'A', ls: 0.064, right: 'X\u00b2', rs: 0.052, left_extension: 0.05, right_extension: 0.04}));

r = new Rule ({stator: 1, left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . scales . push (new scale_B (18, {left: 'B', ls: 0.064, left_extension: 0.05, right_extension: 0.04}));
r . scales . push (new scale_TCTdec (18, {left: 'T', ls: 0.064, left_extension: 0.018}));
r . scales . push (new scale_STdec (18, {left: 'S R T', ls: 0.064, left_extension: 0.018, draw_st_corrections: false, lines: [{left: 0, right: 1, height: 1}]}));
r . scales . push (new scale_SCdec (18, {left: 'S', ls: 0.064, left_extension: 0.02}));
r . scales . push (new scale_C (18, {left: 'C', ls: 0.064, left_extension: 0.048, right_extension: 0.044}));

r = new Rule ({left_margin: 0.16, right_margin: 0.16, rounding: 12}); s . rules . push (r);
r . scales . push (new scale_D (18, {left: 'D', ls: 0.064, right: 'X', rs: 0.052, left_extension: 0.048, right_extension: 0.044}));
r . scales . push (new scale_DI (18, {left: 'DI', ls: 0.064, right: '1/x', rs: 0.052, colour: 'red'}));
r . scales . push (new scale_LL1_down (18, {left: 'LL1', ls: 0.064, right: 'e\u2070\u22c5\u2070\u00b9\u02e3', rs: 0.052, left_extension: 0.005, right_extension: 0.04}));
r . scales . push (new spacer (4));

</script>

<script src="sliderule_application.js"></script>

<script>
changeMarkings ('stator', document . getElementById ('on_side') . checked);
changeMarkings ('hairline', document . getElementById ('on_hairline') . checked);
changeSide (document . getElementById ('visible_front') . checked ? 'front': document . getElementById ('visible_back') . checked ? 'back' : 'both');
</script>

</body>

</html>
